//Software base para OPS010 Modbus Master
//Controlador ESP32
//Chamada das bibliotecas
#include "ModbusRtu.h"
//Mapeamento dos IOs e definição das Seriais
// Definição dos pinos do controlador
//Saidas digiais
#define pin_Y1 13
#define pin_Y2 12
#define pin_Y3 27
#define pin_Y4 26
#define pin_Y5 25
#define pin_Y6 33
#define pin_Y7 32
#define pin_Y8 4

//Entradas digitais
#define pin_X1 15
#define pin_X2 14
#define pin_X3 35
#define pin_X4 5
#define pin_X5 18
#define pin_X6 19
#define pin_X7 34
#define pin_X8 39

//Entradas analógicas
#define pin_AI1 36

//Saídas analógicas
#define pin_AO1 23

//Pinos auxiliares
#define ENTX_pin 2 //Pino de comunicação RS485

//Configuração da biblioteca Modbus
//ID , porta serial , Pino fluxo
Modbus master(0,Serial2,2);
uint8_t u8state = 0;
modbus_t Comm_MB;
unsigned long u32wait;
uint16_t au16data_DI[1];
uint16_t au16data_DO[1];
uint16_t au16data_AI[1];
uint16_t au16data_AO[1];
//Referências do escravo
//au16data_DI => Entradas digitais
//au16data_DO => Saídas digitais
//au16data_AI => Entrada analógica
//au16data_AO => Saidas analógicas

//Variáveis de controle
int OUT_Digitais[8];
int IN_Digitais[8];
int OUT_Analog[1];
int IN_Analog[1];

#include "DI_Ctrl.h"
#include "DO_Ctrl.h"
#include "AI_Ctrl.h"
#include "AO_Ctrl.h"
#include "MB_Ctrl.h"

void setup() {
  //Setup das seriais
  Serial.begin(115200);   //USB
  master.begin(115200);   //RS485
  master.setTimeOut(500); // if there is no answer in 500 ms, roll over

  //Inicializa hardware
  pinMode(pin_X1, INPUT);
  pinMode(pin_X2, INPUT);
  pinMode(pin_X3, INPUT);
  pinMode(pin_X4, INPUT);
  pinMode(pin_X5, INPUT);
  pinMode(pin_X6, INPUT);
  pinMode(pin_X7, INPUT);
  pinMode(pin_X8, INPUT);

  pinMode(pin_Y1, OUTPUT);
  pinMode(pin_Y2, OUTPUT);
  pinMode(pin_Y3, OUTPUT);
  pinMode(pin_Y4, OUTPUT);
  pinMode(pin_Y5, OUTPUT);
  pinMode(pin_Y6, OUTPUT);
  pinMode(pin_Y7, OUTPUT);
  pinMode(pin_Y8, OUTPUT);
  pinMode(ENTX_pin, OUTPUT);

  digitalWrite(pin_Y1, LOW);
  digitalWrite(pin_Y2, LOW);
  digitalWrite(pin_Y3, LOW);
  digitalWrite(pin_Y4, LOW);
  digitalWrite(pin_Y5, LOW);
  digitalWrite(pin_Y6, LOW);
  digitalWrite(pin_Y7, LOW);
  digitalWrite(pin_Y8, LOW);

  // Configuração da saída analógica
  //(Canal, Frequência, Resolução)
  ledcSetup(0, 1000, 12);
  //(Pino, Canal)
  ledcAttachPin(pin_AO1, 0);
}

void loop() {
  //Chamada das funções
  DI_Ctrl();
  DO_Ctrl();
  AI_Ctrl();
  AO_Ctrl();
  MB_Ctrl();
}
